//------------------------------------------------------------------
#property copyright   "copyright mladen"
#property link        "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 clrDimGray
#property indicator_color2 clrLimeGreen
#property indicator_color3 clrOrange
#property indicator_color4 clrOrange
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property strict

extern int                CalcPeriod   = 10;          // Calculation period
extern int                AverPeriod   = 50;          // Average period
extern ENUM_MA_METHOD     CalcMetohod  = MODE_EMA;    // Average method
extern ENUM_APPLIED_PRICE Price        = PRICE_CLOSE; // Price to use

double ma[];
double mada[];
double madb[],avg[];
double slope[],prices[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{ 
   IndicatorBuffers(6);
   SetIndexBuffer(0,avg); 
   SetIndexBuffer(1,ma); 
   SetIndexBuffer(2,mada); 
   SetIndexBuffer(3,madb); 
   SetIndexBuffer(4,slope); 
   SetIndexBuffer(5,prices); 
   return(0); 
}
int deinit()
{
   return(0); 
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start(void)
{    
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit=MathMin(Bars,Bars-1);
         
   //
   //
   //
   //
   //
   
   if (slope[limit]==-1) CleanPoint(limit,mada,madb);
   for (int i=limit; i>=0; i--) prices[i] = (High[ArrayMaximum(High,CalcPeriod,i)]+Low[ArrayMinimum(Low,CalcPeriod,i)])/2.0;
   for (int i=limit; i>=0; i--)
   {
      ma[i]   = iMAOnArray(prices,0,AverPeriod,0,CalcMetohod,i);
      avg[i]  = iMA(NULL,0,AverPeriod,0,CalcMetohod,Price,i);
      ma[i]   = avg[i]-ma[i]; avg[i] = 0;
      mada[i] = EMPTY_VALUE;
      madb[i] = EMPTY_VALUE;
      if (i<Bars-1) slope[i] = slope[i+1];
            if (ma[i]<avg[i]) slope[i] = -1;
            if (ma[i]>avg[i]) slope[i] =  1;
            if (slope[i]==-1) PlotPoint(i,mada,madb,ma);
   }            
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>Bars-2) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>Bars-3) return;
   if (first[i+1] == EMPTY_VALUE)
         if (first[i+2] == EMPTY_VALUE) 
               { first[i]  = from[i]; first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
         else  { second[i] = from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else        { first[i]  = from[i];                          second[i] = EMPTY_VALUE; }
}